<template>
    <div>
        <video-player  class="vjs-custom-skin"
                       ref="videoPlayer"
                       :options="playerOptions"
                       :playsinline="true"
                       @play="onPlayerPlay($event)"
                       @pause="onPlayerPause($event)"
                       @ended="onPlayerEnded($event)"
                       @loadeddata="onPlayerLoadeddata($event)"
                       @waiting="onPlayerWaiting($event)"
                       @playing="onPlayerPlaying($event)"
                       @mousetimedisplay="mousetimedisplay($event)"
                       @timeupdate="onPlayerTimeupdate($event)"
                       @canplay="onPlayerCanplay($event)"
                       @canplaythrough="onPlayerCanplaythrough($event)"
                       @ready="playerReadied($event)"
                       @statechanged="playerStateChanged($event)">
        </video-player>
    </div>
</template>

<script>
    import 'video.js/dist/video-js.css'

    import { videoPlayer } from 'vue-video-player'

    // videojs
    import videojs from 'video.js'
    window.videojs = videojs;
    require('videojs-contrib-hls/dist/videojs-contrib-hls.js');

    require('videojs-contrib-quality-levels');
    require ('videojs-hotkeys');

    export default {
        props: {
            link: {
                required: true,
            },
            frame: {
                required: false,
            },
            start: {
                required: true,
                default: 0
            }
        },
        name: "FilmPlayer",
        components: {
            videoPlayer
        },
        data() {
            return {
                playerOptions: {
                    // videojs and plugin options
                    autoplay: false,
                    muted: false,
                    language: 'ru',
                    responsive: true,
                    sources: [{
                        withCredentials: false,
                        type: "video/mp4",
                        src: this.link
                        // src: '/test.mp4'
                    }],
                    controlBar: {
                        volumePanel: {
                            inline: false
                        },
                        timeDivider: false,
                        durationDisplay: false,
                        qualityLevels: true
                    },
                    flash: { hls: { withCredentials: false }},
                    html5: { hls: { withCredentials: false }},
                    poster: "/images/logo.png"
                },

                thumbnails: { "0": { "src": "http://db.tvcompany.com/aic/A.Dogs.Journey.2019.BDRip.1080p_1080.mp4.png", "style": { "left": "-60px", "width": "1910px", "height": "800px", "clip": "rect(0, 191px, 80px, 0)" } }, "65": { "style": { "left": "-191px", "clip": "rect(0px, 382px, 80px, 191px)" } }, "130": { "style": { "left": "-382px", "clip": "rect(0px, 573px, 80px, 382px)" } }, "195": { "style": { "left": "-573px", "clip": "rect(0px, 764px, 80px, 573px)" } }, "260": { "style": { "left": "-764px", "clip": "rect(0px, 955px, 80px, 764px)" } }, "325": { "style": { "left": "-955px", "clip": "rect(0px, 1146px, 80px, 955px)" } }, "390": { "style": { "left": "-1146px", "clip": "rect(0px, 1337px, 80px, 1146px)" } }, "455": { "style": { "left": "-1337px", "clip": "rect(0px, 1528px, 80px, 1337px)" } }, "520": { "style": { "left": "-1528px", "clip": "rect(0px, 1719px, 80px, 1528px)" } }, "585": { "style": { "left": "191px", "clip": "rect(-80px, 0px, 80px, -191px)" } }, "650": { "style": { "left": "0px", "clip": "rect(-80px, 191px, 80px, 0px)" } }, "715": { "style": { "left": "-191px", "clip": "rect(-80px, 382px, 80px, 191px)" } }, "780": { "style": { "left": "-382px", "clip": "rect(-80px, 573px, 80px, 382px)" } }, "845": { "style": { "left": "-573px", "clip": "rect(-80px, 764px, 80px, 573px)" } }, "910": { "style": { "left": "-764px", "clip": "rect(-80px, 955px, 80px, 764px)" } }, "975": { "style": { "left": "-955px", "clip": "rect(-80px, 1146px, 80px, 955px)" } }, "1040": { "style": { "left": "-1146px", "clip": "rect(-80px, 1337px, 80px, 1146px)" } }, "1105": { "style": { "left": "-1337px", "clip": "rect(-80px, 1528px, 80px, 1337px)" } }, "1170": { "style": { "left": "-1528px", "clip": "rect(-80px, 1719px, 80px, 1528px)" } }, "1235": { "style": { "left": "191px", "clip": "rect(-160px, 0px, 80px, -191px)" } }, "1300": { "style": { "left": "0px", "clip": "rect(-160px, 191px, 80px, 0px)" } }, "1365": { "style": { "left": "-191px", "clip": "rect(-160px, 382px, 80px, 191px)" } }, "1430": { "style": { "left": "-382px", "clip": "rect(-160px, 573px, 80px, 382px)" } }, "1495": { "style": { "left": "-573px", "clip": "rect(-160px, 764px, 80px, 573px)" } }, "1560": { "style": { "left": "-764px", "clip": "rect(-160px, 955px, 80px, 764px)" } }, "1625": { "style": { "left": "-955px", "clip": "rect(-160px, 1146px, 80px, 955px)" } }, "1690": { "style": { "left": "-1146px", "clip": "rect(-160px, 1337px, 80px, 1146px)" } }, "1755": { "style": { "left": "-1337px", "clip": "rect(-160px, 1528px, 80px, 1337px)" } }, "1820": { "style": { "left": "-1528px", "clip": "rect(-160px, 1719px, 80px, 1528px)" } }, "1885": { "style": { "left": "191px", "clip": "rect(-240px, 0px, 80px, -191px)" } }, "1950": { "style": { "left": "0px", "clip": "rect(-240px, 191px, 80px, 0px)" } }, "2015": { "style": { "left": "-191px", "clip": "rect(-240px, 382px, 80px, 191px)" } }, "2080": { "style": { "left": "-382px", "clip": "rect(-240px, 573px, 80px, 382px)" } }, "2145": { "style": { "left": "-573px", "clip": "rect(-240px, 764px, 80px, 573px)" } }, "2210": { "style": { "left": "-764px", "clip": "rect(-240px, 955px, 80px, 764px)" } }, "2275": { "style": { "left": "-955px", "clip": "rect(-240px, 1146px, 80px, 955px)" } }, "2340": { "style": { "left": "-1146px", "clip": "rect(-240px, 1337px, 80px, 1146px)" } }, "2405": { "style": { "left": "-1337px", "clip": "rect(-240px, 1528px, 80px, 1337px)" } }, "2470": { "style": { "left": "-1528px", "clip": "rect(-240px, 1719px, 80px, 1528px)" } }, "2535": { "style": { "left": "191px", "clip": "rect(-320px, 0px, 80px, -191px)" } }, "2600": { "style": { "left": "0px", "clip": "rect(-320px, 191px, 80px, 0px)" } }, "2665": { "style": { "left": "-191px", "clip": "rect(-320px, 382px, 80px, 191px)" } }, "2730": { "style": { "left": "-382px", "clip": "rect(-320px, 573px, 80px, 382px)" } }, "2795": { "style": { "left": "-573px", "clip": "rect(-320px, 764px, 80px, 573px)" } }, "2860": { "style": { "left": "-764px", "clip": "rect(-320px, 955px, 80px, 764px)" } }, "2925": { "style": { "left": "-955px", "clip": "rect(-320px, 1146px, 80px, 955px)" } }, "2990": { "style": { "left": "-1146px", "clip": "rect(-320px, 1337px, 80px, 1146px)" } }, "3055": { "style": { "left": "-1337px", "clip": "rect(-320px, 1528px, 80px, 1337px)" } }, "3120": { "style": { "left": "-1528px", "clip": "rect(-320px, 1719px, 80px, 1528px)" } }, "3185": { "style": { "left": "191px", "clip": "rect(-400px, 0px, 80px, -191px)" } }, "3250": { "style": { "left": "0px", "clip": "rect(-400px, 191px, 80px, 0px)" } }, "3315": { "style": { "left": "-191px", "clip": "rect(-400px, 382px, 80px, 191px)" } }, "3380": { "style": { "left": "-382px", "clip": "rect(-400px, 573px, 80px, 382px)" } }, "3445": { "style": { "left": "-573px", "clip": "rect(-400px, 764px, 80px, 573px)" } }, "3510": { "style": { "left": "-764px", "clip": "rect(-400px, 955px, 80px, 764px)" } }, "3575": { "style": { "left": "-955px", "clip": "rect(-400px, 1146px, 80px, 955px)" } }, "3640": { "style": { "left": "-1146px", "clip": "rect(-400px, 1337px, 80px, 1146px)" } }, "3705": { "style": { "left": "-1337px", "clip": "rect(-400px, 1528px, 80px, 1337px)" } }, "3770": { "style": { "left": "-1528px", "clip": "rect(-400px, 1719px, 80px, 1528px)" } }, "3835": { "style": { "left": "191px", "clip": "rect(-480px, 0px, 80px, -191px)" } }, "3900": { "style": { "left": "0px", "clip": "rect(-480px, 191px, 80px, 0px)" } }, "3965": { "style": { "left": "-191px", "clip": "rect(-480px, 382px, 80px, 191px)" } }, "4030": { "style": { "left": "-382px", "clip": "rect(-480px, 573px, 80px, 382px)" } }, "4095": { "style": { "left": "-573px", "clip": "rect(-480px, 764px, 80px, 573px)" } }, "4160": { "style": { "left": "-764px", "clip": "rect(-480px, 955px, 80px, 764px)" } }, "4225": { "style": { "left": "-955px", "clip": "rect(-480px, 1146px, 80px, 955px)" } }, "4290": { "style": { "left": "-1146px", "clip": "rect(-480px, 1337px, 80px, 1146px)" } }, "4355": { "style": { "left": "-1337px", "clip": "rect(-480px, 1528px, 80px, 1337px)" } }, "4420": { "style": { "left": "-1528px", "clip": "rect(-480px, 1719px, 80px, 1528px)" } }, "4485": { "style": { "left": "191px", "clip": "rect(-560px, 0px, 80px, -191px)" } }, "4550": { "style": { "left": "0px", "clip": "rect(-560px, 191px, 80px, 0px)" } }, "4615": { "style": { "left": "-191px", "clip": "rect(-560px, 382px, 80px, 191px)" } }, "4680": { "style": { "left": "-382px", "clip": "rect(-560px, 573px, 80px, 382px)" } }, "4745": { "style": { "left": "-573px", "clip": "rect(-560px, 764px, 80px, 573px)" } }, "4810": { "style": { "left": "-764px", "clip": "rect(-560px, 955px, 80px, 764px)" } }, "4875": { "style": { "left": "-955px", "clip": "rect(-560px, 1146px, 80px, 955px)" } }, "4940": { "style": { "left": "-1146px", "clip": "rect(-560px, 1337px, 80px, 1146px)" } }, "5005": { "style": { "left": "-1337px", "clip": "rect(-560px, 1528px, 80px, 1337px)" } }, "5070": { "style": { "left": "-1528px", "clip": "rect(-560px, 1719px, 80px, 1528px)" } }, "5135": { "style": { "left": "191px", "clip": "rect(-640px, 0px, 80px, -191px)" } }, "5200": { "style": { "left": "0px", "clip": "rect(-640px, 191px, 80px, 0px)" } }, "5265": { "style": { "left": "-191px", "clip": "rect(-640px, 382px, 80px, 191px)" } }, "5330": { "style": { "left": "-382px", "clip": "rect(-640px, 573px, 80px, 382px)" } }, "5395": { "style": { "left": "-573px", "clip": "rect(-640px, 764px, 80px, 573px)" } }, "5460": { "style": { "left": "-764px", "clip": "rect(-640px, 955px, 80px, 764px)" } }, "5525": { "style": { "left": "-955px", "clip": "rect(-640px, 1146px, 80px, 955px)" } }, "5590": { "style": { "left": "-1146px", "clip": "rect(-640px, 1337px, 80px, 1146px)" } }, "5655": { "style": { "left": "-1337px", "clip": "rect(-640px, 1528px, 80px, 1337px)" } }, "5720": { "style": { "left": "-1528px", "clip": "rect(-640px, 1719px, 80px, 1528px)" } }, "5785": { "style": { "left": "191px", "clip": "rect(-720px, 0px, 80px, -191px)" } }, "5850": { "style": { "left": "0px", "clip": "rect(-720px, 191px, 80px, 0px)" } }, "5915": { "style": { "left": "-191px", "clip": "rect(-720px, 382px, 80px, 191px)" } }, "5980": { "style": { "left": "-382px", "clip": "rect(-720px, 573px, 80px, 382px)" } }, "6045": { "style": { "left": "-573px", "clip": "rect(-720px, 764px, 80px, 573px)" } }, "6110": { "style": { "left": "-764px", "clip": "rect(-720px, 955px, 80px, 764px)" } }, "6175": { "style": { "left": "-955px", "clip": "rect(-720px, 1146px, 80px, 955px)" } }, "6240": { "style": { "left": "-1146px", "clip": "rect(-720px, 1337px, 80px, 1146px)" } }, "6305": { "style": { "left": "-1337px", "clip": "rect(-720px, 1528px, 80px, 1337px)" } }, "6370": { "style": { "left": "-1528px", "clip": "rect(-720px, 1719px, 80px, 1528px)" } }, "6435": { "style": { "left": "191px", "clip": "rect(-800px, 0px, 80px, -191px)" } } },

                duration: 0,

            }
        },
        mounted() {
            console.log('this is current player instance object', this.player)
        },
        computed: {
            player() {
                return this.$refs.videoPlayer.player
            },
            thumbnailsArr() {
                let duration = this.duration;

                let timeStep = Math.floor(duration/100);

                let obj = {};
                let startTime = 0;

                for (let i = 0; i < 100; i++) {
                    let row = Math.floor((i+1)/10);
                    let col = i - row*10;
                    obj[parseInt(startTime)] = startTime === 0 ?
                          {src: this.frame, style: {left: "-60px", width: "1910px", height: "800px", clip: "rect(0, 191px, 80px, 0)" } }
                        : {style: { top: -80*row+"px",left: -191*col+"px", clip: "rect("+ 80*row+"px, "+ 191*(col+1) +"px, "+ 80*(row+1)+"px, "+ 191*col +"px)"}};
                    startTime += timeStep;
                }

                return obj;

            }
        },
        methods: {
            // listen event
            onPlayerPlay(player) {
                this.$emit('statistic');
            },
            onPlayerPause(player) {
                // console.log('player pause!', player)
            },
            onPlayerEnded(player) {
                // console.log('player ended!', player)
            },
            onPlayerLoadeddata(player) {
                // console.log('player Loadeddata!', player)
                this.player.currentTime(this.start);
                this.duration = Math.floor(player.duration());
            },
            onPlayerWaiting(player) {
                // console.log('player Waiting!', player)
            },
            onPlayerPlaying(player) {
                // console.log('player Playing!', player)
            },
            onPlayerTimeupdate(player) {
                this.$emit('playing', player.duration(), player.currentTime());
            },
            onPlayerCanplay(player) {
                // console.log('player Canplay!', player)
            },
            onPlayerCanplaythrough(player) {
                // console.log('player Canplaythrough!', player)
            },
            // or listen state event
            playerStateChanged(playerCurrentState) {
                // console.log('player current update state', playerCurrentState)
            },
            // player is ready
            playerReadied(player) {
                player.hotkeys({
                    volumeStep: 1,
                    seekStep: 5,
                    enableVolumeScroll: true,
                    enableHoverScroll: true,
                    enableQualityLevels: true,
                    enableModifiersForNumbers: false,
                    fullscreenKey: function(event, player) {
                        // override fullscreen to trigger when pressing the F key or Ctrl+Enter
                        return ((event.which === 70) || (event.ctrlKey && event.which === 13));
                    }
                });

            }
        },
        watch: {
            thumbnailsArr: {
                immediate: true,
                handler(val) {
                    if (this.frame && this.duration > 0) {
                        this.player.thumbnails(this.thumbnailsArr);
                    }
                }
            }
        }
    }
</script>

<style >
    .video-js {
        width: 100% !important;
        height: calc( (100vw - 150px)*9 /16) !important;
        max-height: calc(100vh - 230px);
    }
    .video-js.vjs-fullscreen {
        max-height: 100% !important;
    }
    .vjs-poster {
        background-color: #478dcd !important;
        background-size: 250px !important;
    }

    .video-js * {
        outline: none !important;
        text-shadow: none;
    }

    .vjs-custom-skin .video-js .vjs-tech {
        object-fit: contain;
    }

    @media (max-width: 600px) {
        .video-js {
            height: calc( (100vw - 50px)*9 /16) !important;
        }
    }
</style>
